
/*================================================*\

	Lundi 23 novembre 1998

	Arash HABIBI

	Liaison.c

        Le module principal de la couche liaison.

\*================================================*/


#include "Liaison.h"


int ReactionArriveeCommande(int *DataAppli)
/*================================================*\
  Va chercher la commande de la couche application 
  et rend le diagnostique. 
\*================================================*/
{
  int commande =1;		/* TOUT_BAIGNE */
  int descripteur=-1;		/* a priori rien */

  if(OrigineCmdAppli(&commande, &descripteur)==-1)
    return(CRASH);
  
  if(commande==QUIT) return(TERMINE);
  
  else if(commande==ENVOI) 
    *DataAppli = descripteur; 
  
  else /* rien a faire */ ;
  
  return(TOUT_BAIGNE);
}


int ReactionArriveePaquet()
/*================================================*\
   Lit ce qu'il y a a lire venant de l'appli
   le met dans une trame et l'envoie a la couche
   physique. Si tout s'est bien passe, on rend 
   TOUT_BAIGNE, si l'emission est terminee, alors
   on rend EMISSION_FINIE et sinon on rend CRASH.
\*================================================*/
{
    int diagnostic=TOUT_BAIGNE;
    int taille_paquet, taille_trame=0; 
    Paquet_t paquet; 
    Trame_t trame; 

    taille_paquet = 1;
    diagnostic = OrigineApplication(&paquet, 
				    &taille_paquet);
	  
    if((diagnostic!=CRASH)&&(diagnostic!=EMISSION_FINIE))
       {
	 EncapsulerPaquet(paquet,  taille_paquet, 
			  &trame , &taille_trame);
	 
	 diagnostic = VersCouchePhysique(&trame, 
					 taille_trame);
       }
    return(diagnostic);		  
}


int ReactionArriveeTrame()
/*================================================*\
   Lit ce qu'il y a a lire venant de la couche phys
   extrait le paquet d'information et le delivre 
   a l'application. Si tout s'est bien passe, on rend 
   TOUT_BAIGNE, sinon on rend CRASH.
\*================================================*/
{
   int diagnostic = TOUT_BAIGNE; 
   int taille_paquet, taille_trame; 
   Paquet_t paquet; 
   Trame_t trame; 

   taille_trame=4; 
     
   diagnostic = OrigineCouchePhysique (&trame, 
				       &taille_trame);
   if(diagnostic!=CRASH)
      {
	DesEncapsulerPaquet (trame, taille_trame, 
			     &paquet, &taille_paquet);
	
	diagnostic = VersApplication (&paquet, 
				      taille_paquet);
      }
   return(diagnostic);
}


	  		  
void ExecCoucheLiaison(int DataPhys, int CmdAppli)
/*================================================*\

  Cette fonction est celle qui definit le protocole.
  Tel quel, le protocole est squelettique. 

  DataPhys est un descripteur par lequel viennet
      les donnees venant de la couche physique. 

  DataAppli est un descripteur par lequel viennent
      les donnees venant de l'application

  CmdAppli est un descripteur par lequel viennent
      les commandes venant de la couche application
      par exemple les demandes de connexion pour dire
      qu'il y a un nouveau fichier a envoyer. 

  Les evenements susceptibles de survenir sont
  le fait qu'il y ait quelque chose a lire sur 
  l'un des descripteurs, ... ou alors un timeout. 

  Dans un premier temps on n'ecoute que CmdAppli et
  DataPhys. Si l'application a demande une emission
  alors seulement on commence a ecouter DataAppli. 

  Evidemment ceci n'a rien a voir avec HDLC. Les paquets
  sont simplement mis dans les trames sans aucun calcul 
  et envoyes tel quel. Rien n'est garanti, surtout s'il 
  y a des erreurs. 
  			A vous maintenant ...

\*================================================*/
{
   int evenement=1, diagnostic=TOUT_BAIGNE; 
   int DataAppli=RIEN;		/* la source des paquets */

   while((diagnostic!=CRASH)&&
	 (diagnostic!=TERMINE))
     {
       evenement = Attendre(DataAppli, DataPhys, CmdAppli, 0.0);

       if(evenement==-1) diagnostic=CRASH; 
       else 
	 {
	   /*    Si evenement == (arrivee-paquet) ------------------*/
	   /* ou si evenement == (arrivee-paquet-ET-trame)--------- */
	   /* ou si evenement == (arrivee-paquet-ET-cmd) ---------- */
	   /* ou si evenement == (arrivee-paquet-ET-trame-ET-cmd)-- */
	   
	   if((evenement==YaALireSur1__)||(evenement==YaALireSur12_)||
	      (evenement==YaALireSur1_3)||(evenement==YaALireSur123))
	     
	     {diagnostic = ReactionArriveePaquet();
	     if(diagnostic==EMISSION_FINIE) DataAppli=RIEN;}
	   
	   
	   /*   Si evenement == (arrivee-trame) ----------------*/
	   /*ou si evenement == (arrivee-trame-ET-paquet)-------*/
	   /*ou si evenement == (arrivee-trame-ET-cmd)----------*/
	   /*ou si evenement == (arrivee-trame-ET-paquet-ET-cmd-*/
	   
	   if((evenement==YaALireSur_2_)||(evenement==YaALireSur12_)||
	      (evenement==YaALireSur_23)||(evenement==YaALireSur123))

	     diagnostic = ReactionArriveeTrame();

	   
	   /*---Si evenement == (arrivee-d'une-commande) -----*/
	   /*--- etc etc etc ---------------------------------*/
	   
	   if((evenement==YaALireSur__3)||(evenement==YaALireSur1_3)||
	      (evenement==YaALireSur_23)||(evenement==YaALireSur123))
	       
	       diagnostic = ReactionArriveeCommande(&DataAppli);

	   /*--- ici la diagnostique peut etre ---------------*/
	   /*--- soit ENVOI soit TERMINE ---------------------*/
	 }
     }
   VersCmdAppli();		/* pour dire a l'appli que   */
				/* la reception est terminee */
   
   if(diagnostic==CRASH) fprintf(stderr,"Echange interrompu.\n");
   else /* TERMINE */    fprintf(stderr,"Echange termine.\n");
}
