/*=========================================*\

	Jeudi 7 Janvier 1999
	
	Arash Habibi
	
	Timer.h
	
	Les structures de donnees pour les 
	timers. 
	
\*=========================================*/

#ifndef _TIMER_H
#define _TIMER_H

#include "define.h"

#include <signal.h>
#include <sys/time.h>

#define FOR_ALL_TIMERS_IN_LIST(timer) for(((timer)=FirstTimer); ((timer)!=NULL); ((timer)=((timer)->next)))

#define FOR_ALL_TIMERS_IN_LIST_WHILE(timer, cond) for(((timer)=FirstTimer); (((timer)!=NULL)&&(cond)); ((timer)=((timer)->next)))

typedef struct AppliTimer_t
{
	int identite; 
	float duree; 
	struct AppliTimer_t *next; 
} AppliTimer_t; 


void MaskSigAlarm();
void UnmaskSigAlarm();

void InitSysTimer(struct itimerval *SysTimer);
void StopSysTimer();
void SetSysTimerValue(float duree);
float GetSysTimerValue();
void WakeUp();

AppliTimer_t* NewAppliTimer(int identite, float duree);
extern void InitTimers(int TPipe);
void UpdateAllAppliTimers();
void RemoveFirstAppliTimer();
void InsertFirstAppliTimer(AppliTimer_t *timer);
void InsertAppliTimer(AppliTimer_t *timer, AppliTimer_t *prec);
void RemoveAppliTimer(AppliTimer_t *RemovedTimer);
void ClassifyAppliTimerInList(AppliTimer_t *NewTimer);

extern void CheckTimers(char *comment);
extern void StartATimer(int identite, float duree);
extern void StopTimer(int identite);
extern int GetNextExpiredTimerID(int PipeDesc);

void TimeoutHandler();


#endif
