
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	main.c

	Programme HDLC
	
	HDLC 1 ou HDLC 2 : lance une station avec 
		avec l'identite 1 ou 2. L'identite 
		sert seulement a nommer les sockets
		et a appeler les fichiers recus. 
		Par defaut HDLC 1 aura sock_station1
		et HDLC 2 aura sock_station2. 

		Ensuite, les commandes possibles 
		sont "envoi <totofile>" et "quit". 
		
\*================================================*/

#include "Timer.h"
#include "Application.h"
#include "Liaison.h"
#include "Physique.h"
#include "CtrlC_Propre.h"

#include "BitABitToolbox.h"
#include "Detection.h"



void ExitPropre()
/*================================================*\
  Pour terminer le processus en fermant fichiers, 
  terminaux et sockets. 
\*================================================*/
{ 
  StopApplication();
  StopCouchePhysique(); 
  exit(0);
}



void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{ 
  int i; 
  int diviseur=19;  
  short dividende=0;
  short reste=50; 

  SetNiemeBit(&dividende, sizeof(dividende), 0,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 1,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 2,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 3,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 4,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 5,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 6,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 7,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 8,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 9,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 10, 1);
  SetNiemeBit(&dividende, sizeof(dividende), 11, 0);
  SetNiemeBit(&dividende, sizeof(dividende), 12, 1);
  SetNiemeBit(&dividende, sizeof(dividende), 13, 1);
  CheckBitABit(&dividende, sizeof(dividende),"dividende");
  CheckBitABit(&diviseur , sizeof(diviseur),"diviseur");
  CheckBitABit(&reste, sizeof(reste),"reste avant");

  reste = ResteDivisionModulo2(&dividende, sizeof(dividende), diviseur);
  CheckBitABit(&reste, sizeof(reste),"reste apres");

  SetNiemeBit(&dividende, sizeof(dividende), 0,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 1,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 2,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 3,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 4,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 5,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 6,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 7,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 8,  1);
  SetNiemeBit(&dividende, sizeof(dividende), 9,  0);
  SetNiemeBit(&dividende, sizeof(dividende), 10, 1);
  SetNiemeBit(&dividende, sizeof(dividende), 11, 0);
  SetNiemeBit(&dividende, sizeof(dividende), 12, 1);
  SetNiemeBit(&dividende, sizeof(dividende), 13, 1);

  for(i=0; i<32; i++)
    {
      CheckBitABit(&dividende, sizeof(dividende),"dividende");
      DecalageDroite(&dividende, sizeof(dividende), -1);
    }
}
