
/*================================================*\

	Lundi 23 novembre 1998

	Arash HABIBI

	Liaison.h

        Tout ce qui concerne la couche liaison

\*================================================*/


#ifndef _LIAISON_H
#define _LIAISON_H

#include "define.h"
#include "Toolbox.h"
#include "Attente.h"

typedef struct CoucheLia_t
{				/* les descripteurs de tubes */
  int				/* representant les SAP      */
    Conn_AL,			/* Connexion Appli a Liaion  */
    Conn_LA,			/* Connexion Liaion a Appli  */
    Data_AL,			/* Data Appli a Liaion       */
    Data_LA,			/* Data Liaison a Appli      */
    Disc_AL,			/* Deconnexion Appli a Lia   */
    Disc_LA,			/* Deconnexion Lia a Appli   */
  
    Conn_PL,			/* Connexion Phys a Liaion  */
    Conn_LP,			/* Connexion Liaion a Phys  */
    Data_PL,			/* Data Phys a Liaion       */
    Data_LP,			/* Data Liaison a Phys      */
    Disc_PL,			/* Deconnexion Phys a Lia   */
    Disc_LP;			/* Deconnexion Lia a Phys   */
  
  int identite;			/* 0 ou 1 selon qu'on est */
				/* station1 ou station2   */
} CoucheLia_t;


void InitCoucheLia(CoucheLia_t *CchLia, int id, int conn_la, int conn_al, int data_la, int data_al, int disc_la, int disc_al, int data_lp, int data_pl, int disc_lp, int disc_pl);

extern void FreeCoucheLia(CoucheLia_t *CchLia); 

void Lia_ViderTubeInterface(int tube);
int  Lia_ExtrairePaquet(int Data_PL, int Data_LA);
int  Lia_EncapsulerPaquet(int Data_AL, int Data_LP);
void Lia_DisconnectRequest(int Disc_LP);

void Lia_Boucle(CoucheLia_t *CchLia);

#endif
