/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	main.c

	Un main pour la fonction GetAndBindSocket,
	mais aussi pour la fonction WriteNetworkAddress
	qui en fonction d'un domaine, d'un nom d'hote
	et d'un numero de port, fournit une adresse 
	qui est celle de la socket distante, en veillant
	a la portabilite du code (en tenant compte des
	bigendians et des little endians.      
	
\*================================================*/


#include "SocketToolbox.h"


void main(int argc, char **argv)
/*================================================*\
   C'est un programme qui ne fait que rendre
   une socket fixee a un numero de port. 
\*================================================*/
{	
	int desc_sock, type;
	struct sockaddr_in adresse_loc, adresse_dist; 
	AdresseIP_t IP; 
	
	if(argc!=5) {printf("Usage : DistAddress type loc_port dist_Host dist_port\n"); exit(1);}
	
/* ---- Interpretation de argv[1] ------------------------ */
	
	if(strcmp(argv[1],"SOCK_DGRAM")==0) type = SOCK_DGRAM; 
	else if(strcmp(argv[1],"SOCK_STREAM")==0) type = SOCK_STREAM; 
	else 
	{printf("Le type doit etre soit SOCK_DGRAM soit SOCK_STERAM et non %s\n",
	 argv[1]); exit(1);}
	 
/* ---- creation et attachement de la socket locale ------- */
	
	desc_sock = GetAndBindSocket(type, atoi(argv[2]), &adresse_loc);
	
	printf("Socket locale %d attache au port local numero %d\n",
		desc_sock, adresse_loc.sin_port);
		
/* ---- preparation de l'adresse de la socket distante ---- */
	
	adresse_dist = WriteNetworkAddress(argv[3], atoi(argv[4]));
	
/* ---- verification du contenu de l'adresse preparee- ---- */
	
	LongToAdresseIP(ntohl(adresse_dist.sin_addr.s_addr), &IP);
	
	printf("Adresse distante : hote %d.%d.%d.%d numero de port %d\n",
		IP.n1, IP.n2, IP.n3, IP.n4, ntohs(adresse_dist.sin_port));
}	 
