
/*===============================================*\
	Vendredi 11 Septembre 1998

	Arash HABIBI

	GetAndBindSocket.c

    C'est une fonction qui sera utilisee dans toutes
    les autres manips. Elle se debrouille pour ouvrir
    une socket et l'attacher, soit a un port specifique
    donnee dans le parametre nb_port, soit au premier
    port libre, (si nb_port est libre)
    Le troisieme parametre, comme pour getsockname est 
    en meme temps entree et sortie. Elle doit deja 
    contenir une structure sockaddr_in. Au retour 
    ce parametre contient l'adresse de la socket
    effectivement allouee.   
	
\*================================================*/


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>


int GetAndBindSocket(int type, int nb_port, struct sockaddr_in *adresse_loc)
/*================================================*\
\*================================================*/
{
	int desc, res, taille; 

	if(adresse_loc==NULL) return(-1); 
	/* Il faut que adresse_loc soit deja allouee */

	desc = socket(AF_INET, type, 0);

	if(desc == -1) {perror("socket"); exit(1);}
	else printf("Socket creee.\n");
	
	/*--- preparation de la structure adresse locale ---*/
		
	adresse_loc->sin_family      = AF_INET;
	adresse_loc->sin_port        = nb_port;  
	adresse_loc->sin_addr.s_addr = INADDR_ANY; 
	
	/*--- INADDR_ANY donne l'adresse IP de la machine locale ---*/
	
	/* Toujours pour la portabilite sur little endians  */
	/* adresse_loc->sin_port = htons(nb_port);          */
	/* adresse_loc->sin_addr.s_addr = htonl(INADDR_ANY) */

	res = bind(desc, (struct sockaddr *)adresse_loc, 
		sizeof(*adresse_loc));
	
	if(res == -1) {perror("bind"); exit(1);}
	else printf("Socket attachee.\n");
	
	taille = sizeof(*adresse_loc);
	
	res = getsockname(desc, (struct sockaddr *)adresse_loc, 
		&taille);
	
	/* ---- Toujours la portabilite little-endians ---- */
	/* adresse_loc->sin_port =			    */
	/*	       ntohs(adresse_loc->sin_port);        */
	/* adresse_loc->sin_addr.s_addr = 	            */
	/*	       ntohl(adresse_loc->sin_addr.s_addr); */

	return(desc);
}
